import { EditorState, TextSelection, Transaction } from "prosemirror-state";
import { EditorView, EditorView as PMEditorView } from "prosemirror-view";
import { Node } from "prosemirror-model";
import CodeMirror, { Editor } from "codemirror";
import { CodeBlockSettings } from "./types";
export declare function computeChange(oldVal: string, newVal: string): {
    from: number;
    to: number;
    text: string;
} | null;
export declare const asProseMirrorSelection: (pmView: PMEditorView, cm: Editor, getPos: (() => number) | boolean) => TextSelection<any>;
export declare const forwardSelection: (cm: Editor, pmView: PMEditorView, getPos: (() => number) | boolean) => void;
export declare const valueChanged: (cm: Editor, node: Node, getPos: (() => number) | boolean, view: PMEditorView) => void;
export declare const codeMirrorKeymap: (getCm: () => Editor, view: EditorView, getPos: (() => number) | boolean, getNode: () => Node, settings: CodeBlockSettings) => CodeMirror.KeyMap;
export declare const codeBlockArrowHandlers: {
    ArrowLeft: (state: EditorState, dispatch: ((tr: Transaction) => void) | undefined, view?: EditorView<any> | undefined) => boolean;
    ArrowRight: (state: EditorState, dispatch: ((tr: Transaction) => void) | undefined, view?: EditorView<any> | undefined) => boolean;
    ArrowUp: (state: EditorState, dispatch: ((tr: Transaction) => void) | undefined, view?: EditorView<any> | undefined) => boolean;
    ArrowDown: (state: EditorState, dispatch: ((tr: Transaction) => void) | undefined, view?: EditorView<any> | undefined) => boolean;
};
